!
subroutine DE35(DS2, A, B, N, M, Order, Y, DY)
!     DE46R  DE47R  :
! ..,  ..   
!   . . . , 1990.
interface
  subroutine DS2(X, Y, DY, DDY)
  real, intent(in):: X, Y(:), DY(:)
  real:: DDY(:)
  end subroutine DS2
end interface
real, intent(in):: A, B
integer, intent(in):: N, M, Order
real, intent(inout):: Y(M), DY(M)
integer, parameter:: MaxOrder=6
real, parameter:: C(0:MaxOrder-1)=(/1.0, 0.5, 5.0/12.0, 0.375,     &
  251.0/720.0, 95.0/288.0/)
real, parameter:: E(0:MaxOrder-1)=(/1.0, 0.0, 1.0/12.0, 1.0/12.0,  &
  19.0/240.0, 3.0/40.0/)
real, allocatable:: YH(:), DYH(:), Z(:), F(:), DF(:,:), S1(:), S2(:), S3(:), W(:)
real:: H, X, XH, Err
integer:: j, k, Morder
!begin
  if (A==B) return
  Morder=Order
  if (Morder>MaxOrder) Morder=MaxOrder
  if (N<Morder) return
  H=(B-A)/float(N)
  allocate(YH(M), DYH(M), Z(M), F(M), DF(1:M,0:Morder), S1(M), S2(M), S3(M), W(M))
  call DE34(DS2, A, Y, DY, H, M, Morder, Z, DF, XH, YH, DYH, Err)
  do k=1, N
    X=A+H*float(k)
    S1(:)=Z(:)+DF(:,0); S2(:)=DY(:)+DF(:,0); S3=DF(:,0)
    do j=1, Morder-1
      S1(:)=S1(:)+E(j)*DF(:,j)
      S2(:)=S2(:)+C(j)*DF(:,j)
      S3(:)=S3(:)+DF(:,j)
    end do
    YH(:)=Y(:)+H*S1(:); DY(:)=S2(:)
    call DS2(X, YH, DY, F)
    F(:)=H*F(:)
    DY(:)=DY(:)-C(Morder-1)*S3(:)+C(Morder-1)*F(:)
    S1(:)=S1(:)-E(Morder-1)*S3(:)+E(Morder-1)*F(:)
    Y(:)=Y(:)+H*S1(:)
    Z(:)=S1(:)
    do j=0, Morder-1
      W(:)=DF(:,j); DF(:,j)=F(:); F(:)=F(:)-W(:)
    end do
!   DF(:,Morder)=F(:)
  end do
  deallocate(YH, DYH, Z, F, DF, S1, S2, S3, W)
  return
end subroutine DE35
